"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-2025020308
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.hci_ip_address import HciIpAddress
    from intersight.model.hci_node_relationship import HciNodeRelationship
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['HciIpAddress'] = HciIpAddress
    globals()['HciNodeRelationship'] = HciNodeRelationship


class HciDiskAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'HCI.DISK': "hci.Disk",
        },
        ('object_type',): {
            'HCI.DISK': "hci.Disk",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'cluster_ext_id': (str,),  # noqa: E501
            'cluster_name': (str,),  # noqa: E501
            'cvm_ip_address': (HciIpAddress,),  # noqa: E501
            'disk_ext_id': (str,),  # noqa: E501
            'disk_size_bytes': (int,),  # noqa: E501
            'firmware_version': (str,),  # noqa: E501
            'has_boot_partitions_only': (bool,),  # noqa: E501
            'host_name': (str,),  # noqa: E501
            'is_boot_disk': (bool,),  # noqa: E501
            'is_data_migrated': (bool,),  # noqa: E501
            'is_diagnostic_info_available': (bool,),  # noqa: E501
            'is_error_found_in_logs': (bool,),  # noqa: E501
            'is_marked_for_removal': (bool,),  # noqa: E501
            'is_mounted': (bool,),  # noqa: E501
            'is_online': (bool,),  # noqa: E501
            'is_password_protected': (bool,),  # noqa: E501
            'is_planned_outage': (bool,),  # noqa: E501
            'is_self_encrypting_drive': (bool,),  # noqa: E501
            'is_self_managed_nvme': (bool,),  # noqa: E501
            'is_spdk_managed': (bool,),  # noqa: E501
            'is_suspected_unhealthy': (bool,),  # noqa: E501
            'is_under_diagnosis': (bool,),  # noqa: E501
            'is_unhealthy': (bool,),  # noqa: E501
            'location': (int,),  # noqa: E501
            'model': (str,),  # noqa: E501
            'mount_path': (str,),  # noqa: E501
            'node_ext_id': (str,),  # noqa: E501
            'node_ip_address': (HciIpAddress,),  # noqa: E501
            'nvme_pcie_path': (str,),  # noqa: E501
            'physical_capacity_bytes': (int,),  # noqa: E501
            'serial_number': (str,),  # noqa: E501
            'service_vm_id': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'storage_pool_ext_id': (str,),  # noqa: E501
            'storage_tier': (str,),  # noqa: E501
            'target_firmware_version': (str,),  # noqa: E501
            'vendor': (str,),  # noqa: E501
            'node': (HciNodeRelationship,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'cluster_ext_id': 'ClusterExtId',  # noqa: E501
        'cluster_name': 'ClusterName',  # noqa: E501
        'cvm_ip_address': 'CvmIpAddress',  # noqa: E501
        'disk_ext_id': 'DiskExtId',  # noqa: E501
        'disk_size_bytes': 'DiskSizeBytes',  # noqa: E501
        'firmware_version': 'FirmwareVersion',  # noqa: E501
        'has_boot_partitions_only': 'HasBootPartitionsOnly',  # noqa: E501
        'host_name': 'HostName',  # noqa: E501
        'is_boot_disk': 'IsBootDisk',  # noqa: E501
        'is_data_migrated': 'IsDataMigrated',  # noqa: E501
        'is_diagnostic_info_available': 'IsDiagnosticInfoAvailable',  # noqa: E501
        'is_error_found_in_logs': 'IsErrorFoundInLogs',  # noqa: E501
        'is_marked_for_removal': 'IsMarkedForRemoval',  # noqa: E501
        'is_mounted': 'IsMounted',  # noqa: E501
        'is_online': 'IsOnline',  # noqa: E501
        'is_password_protected': 'IsPasswordProtected',  # noqa: E501
        'is_planned_outage': 'IsPlannedOutage',  # noqa: E501
        'is_self_encrypting_drive': 'IsSelfEncryptingDrive',  # noqa: E501
        'is_self_managed_nvme': 'IsSelfManagedNvme',  # noqa: E501
        'is_spdk_managed': 'IsSpdkManaged',  # noqa: E501
        'is_suspected_unhealthy': 'IsSuspectedUnhealthy',  # noqa: E501
        'is_under_diagnosis': 'IsUnderDiagnosis',  # noqa: E501
        'is_unhealthy': 'IsUnhealthy',  # noqa: E501
        'location': 'Location',  # noqa: E501
        'model': 'Model',  # noqa: E501
        'mount_path': 'MountPath',  # noqa: E501
        'node_ext_id': 'NodeExtId',  # noqa: E501
        'node_ip_address': 'NodeIpAddress',  # noqa: E501
        'nvme_pcie_path': 'NvmePciePath',  # noqa: E501
        'physical_capacity_bytes': 'PhysicalCapacityBytes',  # noqa: E501
        'serial_number': 'SerialNumber',  # noqa: E501
        'service_vm_id': 'ServiceVmId',  # noqa: E501
        'status': 'Status',  # noqa: E501
        'storage_pool_ext_id': 'StoragePoolExtId',  # noqa: E501
        'storage_tier': 'StorageTier',  # noqa: E501
        'target_firmware_version': 'TargetFirmwareVersion',  # noqa: E501
        'vendor': 'Vendor',  # noqa: E501
        'node': 'Node',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
    }

    read_only_vars = {
        'cluster_ext_id',  # noqa: E501
        'cluster_name',  # noqa: E501
        'disk_ext_id',  # noqa: E501
        'disk_size_bytes',  # noqa: E501
        'firmware_version',  # noqa: E501
        'has_boot_partitions_only',  # noqa: E501
        'host_name',  # noqa: E501
        'is_boot_disk',  # noqa: E501
        'is_data_migrated',  # noqa: E501
        'is_diagnostic_info_available',  # noqa: E501
        'is_error_found_in_logs',  # noqa: E501
        'is_marked_for_removal',  # noqa: E501
        'is_mounted',  # noqa: E501
        'is_online',  # noqa: E501
        'is_password_protected',  # noqa: E501
        'is_planned_outage',  # noqa: E501
        'is_self_encrypting_drive',  # noqa: E501
        'is_self_managed_nvme',  # noqa: E501
        'is_spdk_managed',  # noqa: E501
        'is_suspected_unhealthy',  # noqa: E501
        'is_under_diagnosis',  # noqa: E501
        'is_unhealthy',  # noqa: E501
        'location',  # noqa: E501
        'model',  # noqa: E501
        'mount_path',  # noqa: E501
        'node_ext_id',  # noqa: E501
        'nvme_pcie_path',  # noqa: E501
        'physical_capacity_bytes',  # noqa: E501
        'serial_number',  # noqa: E501
        'service_vm_id',  # noqa: E501
        'status',  # noqa: E501
        'storage_pool_ext_id',  # noqa: E501
        'storage_tier',  # noqa: E501
        'target_firmware_version',  # noqa: E501
        'vendor',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """HciDiskAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hci.Disk", must be one of ["hci.Disk", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hci.Disk", must be one of ["hci.Disk", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            cluster_ext_id (str): The unique identifier of the cluster.. [optional]  # noqa: E501
            cluster_name (str): The name of the cluster this disk belongs to.. [optional]  # noqa: E501
            cvm_ip_address (HciIpAddress): [optional]  # noqa: E501
            disk_ext_id (str): The unique identifier of the disk.. [optional]  # noqa: E501
            disk_size_bytes (int): The size of the disk in bytes.. [optional]  # noqa: E501
            firmware_version (str): The current firmware version of the disk.. [optional]  # noqa: E501
            has_boot_partitions_only (bool): Indicates if the disk is boot only and no disk operation to be run on it.. [optional]  # noqa: E501
            host_name (str): The name of the host the disk is running on.. [optional]  # noqa: E501
            is_boot_disk (bool): Indicate if the disk is a boot disk.. [optional]  # noqa: E501
            is_data_migrated (bool): Indicates whether the disk data is migrated.. [optional]  # noqa: E501
            is_diagnostic_info_available (bool): Indicates whether the diagnostic information is available.. [optional]  # noqa: E501
            is_error_found_in_logs (bool): Indicates whether the error is found in kernel logs.. [optional]  # noqa: E501
            is_marked_for_removal (bool): Indicates whether the disk is marked for removal.. [optional]  # noqa: E501
            is_mounted (bool): Indicates whether the disk is mounted.. [optional]  # noqa: E501
            is_online (bool): Indicates whether the disk is online or offline.. [optional]  # noqa: E501
            is_password_protected (bool): The password protection status of the disk.. [optional]  # noqa: E501
            is_planned_outage (bool): Indicates if diagnostics are running on the Disk.. [optional]  # noqa: E501
            is_self_encrypting_drive (bool): The self-encrypting drive status of the disk.. [optional]  # noqa: E501
            is_self_managed_nvme (bool): Indicates if the NVMe Disk is self managed and no host/CVM reboot is required.. [optional]  # noqa: E501
            is_spdk_managed (bool): Indicates if NVMe device is managed by storage performance development  kit (SPDK).. [optional]  # noqa: E501
            is_suspected_unhealthy (bool): Indicates whether the disk is suspected unhealthy.. [optional]  # noqa: E501
            is_under_diagnosis (bool): Indicates whether the disk is under diagnosis.. [optional]  # noqa: E501
            is_unhealthy (bool): Indicates whether the disk is unhealthy.. [optional]  # noqa: E501
            location (int): The location of the disk in the node.. [optional]  # noqa: E501
            model (str): The model of the reported disk.. [optional]  # noqa: E501
            mount_path (str): The mount path of the disk.. [optional]  # noqa: E501
            node_ext_id (str): The unique identifier of the node.. [optional]  # noqa: E501
            node_ip_address (HciIpAddress): [optional]  # noqa: E501
            nvme_pcie_path (str): The PCIe path of the NVMe disk.. [optional]  # noqa: E501
            physical_capacity_bytes (int): The physical capacity of the disk in bytes.. [optional]  # noqa: E501
            serial_number (str): The serial number of the disk.. [optional]  # noqa: E501
            service_vm_id (str): The unique identifier of the service VM on the node.. [optional]  # noqa: E501
            status (str): The status of the disk such as NORMAL, MARKED_FOR_REMOVAL_BUT_NOT_DETACHABLE, DETACHABLE, DATA_MIGRATION_INITIATED.. [optional]  # noqa: E501
            storage_pool_ext_id (str): The unique identifier of the storage pool.. [optional]  # noqa: E501
            storage_tier (str): The storage tier of the disk such as SSD_PCIE, SSD_SATA, DAS_SATA, CLOUD, SSD_MEM_NVME.. [optional]  # noqa: E501
            target_firmware_version (str): The target firmware version of the disk.. [optional]  # noqa: E501
            vendor (str): The vendor of the reported disk.. [optional]  # noqa: E501
            node (HciNodeRelationship): [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = "hci.Disk" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "hci.Disk")
        object_type = "hci.Disk" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "hci.Disk")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """HciDiskAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "hci.Disk", must be one of ["hci.Disk", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "hci.Disk", must be one of ["hci.Disk", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            cluster_ext_id (str): The unique identifier of the cluster.. [optional]  # noqa: E501
            cluster_name (str): The name of the cluster this disk belongs to.. [optional]  # noqa: E501
            cvm_ip_address (HciIpAddress): [optional]  # noqa: E501
            disk_ext_id (str): The unique identifier of the disk.. [optional]  # noqa: E501
            disk_size_bytes (int): The size of the disk in bytes.. [optional]  # noqa: E501
            firmware_version (str): The current firmware version of the disk.. [optional]  # noqa: E501
            has_boot_partitions_only (bool): Indicates if the disk is boot only and no disk operation to be run on it.. [optional]  # noqa: E501
            host_name (str): The name of the host the disk is running on.. [optional]  # noqa: E501
            is_boot_disk (bool): Indicate if the disk is a boot disk.. [optional]  # noqa: E501
            is_data_migrated (bool): Indicates whether the disk data is migrated.. [optional]  # noqa: E501
            is_diagnostic_info_available (bool): Indicates whether the diagnostic information is available.. [optional]  # noqa: E501
            is_error_found_in_logs (bool): Indicates whether the error is found in kernel logs.. [optional]  # noqa: E501
            is_marked_for_removal (bool): Indicates whether the disk is marked for removal.. [optional]  # noqa: E501
            is_mounted (bool): Indicates whether the disk is mounted.. [optional]  # noqa: E501
            is_online (bool): Indicates whether the disk is online or offline.. [optional]  # noqa: E501
            is_password_protected (bool): The password protection status of the disk.. [optional]  # noqa: E501
            is_planned_outage (bool): Indicates if diagnostics are running on the Disk.. [optional]  # noqa: E501
            is_self_encrypting_drive (bool): The self-encrypting drive status of the disk.. [optional]  # noqa: E501
            is_self_managed_nvme (bool): Indicates if the NVMe Disk is self managed and no host/CVM reboot is required.. [optional]  # noqa: E501
            is_spdk_managed (bool): Indicates if NVMe device is managed by storage performance development  kit (SPDK).. [optional]  # noqa: E501
            is_suspected_unhealthy (bool): Indicates whether the disk is suspected unhealthy.. [optional]  # noqa: E501
            is_under_diagnosis (bool): Indicates whether the disk is under diagnosis.. [optional]  # noqa: E501
            is_unhealthy (bool): Indicates whether the disk is unhealthy.. [optional]  # noqa: E501
            location (int): The location of the disk in the node.. [optional]  # noqa: E501
            model (str): The model of the reported disk.. [optional]  # noqa: E501
            mount_path (str): The mount path of the disk.. [optional]  # noqa: E501
            node_ext_id (str): The unique identifier of the node.. [optional]  # noqa: E501
            node_ip_address (HciIpAddress): [optional]  # noqa: E501
            nvme_pcie_path (str): The PCIe path of the NVMe disk.. [optional]  # noqa: E501
            physical_capacity_bytes (int): The physical capacity of the disk in bytes.. [optional]  # noqa: E501
            serial_number (str): The serial number of the disk.. [optional]  # noqa: E501
            service_vm_id (str): The unique identifier of the service VM on the node.. [optional]  # noqa: E501
            status (str): The status of the disk such as NORMAL, MARKED_FOR_REMOVAL_BUT_NOT_DETACHABLE, DETACHABLE, DATA_MIGRATION_INITIATED.. [optional]  # noqa: E501
            storage_pool_ext_id (str): The unique identifier of the storage pool.. [optional]  # noqa: E501
            storage_tier (str): The storage tier of the disk such as SSD_PCIE, SSD_SATA, DAS_SATA, CLOUD, SSD_MEM_NVME.. [optional]  # noqa: E501
            target_firmware_version (str): The target firmware version of the disk.. [optional]  # noqa: E501
            vendor (str): The vendor of the reported disk.. [optional]  # noqa: E501
            node (HciNodeRelationship): [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = "hci.Disk" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "hci.Disk")
        object_type = "hci.Disk" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "hci.Disk")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
